#include <hmg.ch>

Function Main

  PUBLIC cFileName , cFileD  , Nuevo , oExcel
  PUBLIC ficheraax , ficheraaxA , nPos

  DEFINE WINDOW main ;
         AT 350 , 605 ;
         WIDTH 452 HEIGHT 306 ;
         TITLE "" ;
         NOMAXIMIZE MAIN

    DEFINE BUTTON Button_1
        ROW    040
        COL    020
        WIDTH  100
        HEIGHT 028
        ACTION GetDbfFileName()
        CAPTION "Select Dbf"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE Nil
        PICTALIGNMENT TOP
    END BUTTON

    DEFINE LABEL Label_1
        ROW    047
        COL    156 
        WIDTH  250
        HEIGHT 028
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
    END LABEL

    DEFINE BUTTON Button_2
        ROW    120
        COL    020
        WIDTH  100
        HEIGHT 028
        ACTION  Export_Xls()     
        CAPTION "Export File"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE Nil
        PICTALIGNMENT TOP
    END BUTTON

    DEFINE TEXTBOX Text_1
        ROW    082
        COL    150
        WIDTH  250
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        CASECONVERT NONE
        BACKCOLOR Nil
        FONTCOLOR Nil
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX

    DEFINE LABEL Label_2
        ROW    083
        COL    020
        WIDTH  120
        HEIGHT 028
        VALUE "Excel FileName"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR Nil
        FONTCOLOR Nil
    END LABEL
 
     DEFINE LABEL Label_3
        ROW    140
        COL    159  
        WIDTH  250
        HEIGHT 028
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
    END LABEL

    DEFINE  CHECKBOX Check_1
        ROW    166
        COL    159 
        WIDTH  150  
        CAPTION SPACE(3)+'Excel Pdf ?'       
        VALUE  .T.
        FONTNAME "Arial"
        FONTSIZE 9
        FONTBOLD .T.  
        ONCHANGE CambiaXq()
    END CHECKBOX

    DEFINE BUTTON Button_3
        ROW    180
        COL    020
        WIDTH  100
        HEIGHT 028
        ACTION Main.Release
        CAPTION "Exit"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE Nil
        PICTALIGNMENT TOP
    END BUTTON

 END WINDOW

    Main.Label_3.Value := "Yes File Excel.Pdf" 

 Main.Center
 Main.Activate

Return

*------------------------------------------------------------------------*
FUNCTION GetDbfFileName()
*------------------------------------------------------------------------*
  
  Public cFileName := ''
  
  cFileName := UPPER(Getfile ( { {'Dbf Files','*.dbf'} } , 'Select File' , , .f. , .f., 1))

 If len(cFileName) > 4
  Main.Text_1.Value := Substr(cFilename,1,len(cFilename)-4)
 EndIf 
 
 IF cFileName < SPACE(1)
      msgStop('Missing File','Attention !!!')
      return nil
 ENDIF

   *---------------  File + ".dbf" =  Calculo Digitos ------------------*

  cFileD := cFileName

  ficheraax := LEFT( cFileD , LEN(cFileD) ) 

  nPos := RAT("\", cFileD) 

  ficheraaxA  = SUBSTR(cFileD, 1, nPos) 

*----------------------------------------------------------------------*

  cFileD := cFileName

  ficheraax := RIGHT( cFileD , LEN(cFileD) - RAT("\", cFileD ))  

*---------------  Solo File  =  Calculo Digitos ----------------------*

   Nuevo =  LEFT ( ficheraax , LEN( ficheraax ) - 4 ) 
     
   Main.Label_1.Value := alltrim(Nuevo + ".dbf")

 RETURN NIL

*------------------------------------------------------------------------*
Function DbfToExcel(cExcelName) // We need full path for both files
*------------------------------------------------------------------------*
private oExcel := nil
private oActive := nil
private nFields := 0
private cRange := ''
private aStructure := {}

nRecNo := LastRec()
aStructure := DBStruct()
nFields := len(aStructure)

oExcel:= TOleAuto():New( "Excel.Application" )

oExcel:WorkBooks:Open(cExcelName+".dbf")    //  cDbfFile)
oActive := oExcel:ActiveSheet()
oExcel:DisplayAlerts := .F.               // Doesn't display Excel alerts  

oActive:PageSetup:Zoom := .F.                     //Fit all columns in one page, and page orientation to landscape
oActive:PageSetup:Orientation := 2 
oActive:PageSetup:FitToPagesTall := .F.
oActive:PageSetup:FitToPagesWide := 1                       
oExcel:Visible := .F.                             // Do not show the excel file on screen 

oExcel:ActiveWorkbook:ExportAsFixedFormat(0,cExcelName + ".PDF")  //Export the excel file as PDF
oExcel:Application:Quit()

RELEASE oActive
RELEASE oExcel

Msginfo("Finished!!!","Done!")

return

*--------------------------------------------*
FUNCTION Export_Xls()
*--------------------------------------------*

CambiaXq()

 IF aChecboQ = "True"   
  CLOSE DATABASES
  use &Nuevo    
  COPY TO &(Nuevo+".xls")
  CLOSE DATABASES
  Main.Label_3.Value := " "
  Main.Label_3.Value := alltrim(Nuevo + ".Pdf")

  DbfToExcel(alltrim(Main.Text_1.Value)) 

ELSE
  CLOSE DATABASES
  use &Nuevo    
  COPY TO &(Nuevo+".xls")
  CLOSE DATABASES

  Msginfo("Finished!!!","Done!")

  return

ENDIF

return

*------------------------*
  FUNCTION   CambiaXq()
*------------------------*

  PUBLIC aChecboQ

   aChecboQ  := ( IIF(Main.Check_1.Value,"True","False") )
 
   IF aChecboQ = "True"   

     Main.Label_3.Value := "Yes File Excel.Pdf"

   ELSE

     Main.Label_3.Value := "No File Excel.Pdf"
  
      
  ENDIF

RETURN NIL

*-----------------------------------------------------------------------------------------------------------*



